<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<app-role-checker [allowedRoles]="[admin, nodeOperator]">
  <ng-template let-authorized>
    <div class="w-full flex items-center justify-between pb-10 gap-10">
      <div class="flex items-center">
        <app-type-icon [icon]="adapter.icon" [color]="adapter.color" [size]="44"> </app-type-icon>
        <div class="leading-none">
          <div class="text-md font-semibold text-white leading-none pl-4" [ngClass]="{ 'pt-3': authorized }">
            {{ adapter.name }}
          </div>
          <app-change-connection-button
            *ngIf="authorized"
            [adapterConnection]="connection"
          ></app-change-connection-button>
        </div>
        <div class="pl-8 pt-1">
          <app-adapter-help [adapter]="adapter"></app-adapter-help>
        </div>
      </div>
      <div *ngIf="authorized" class="flex flex-col text-base font-semibold leading-none">
        <div class="text-text-300 text-sm pl-4 pt-2">
          Delete <span class="text-white">{{ connection.op | lowercase }}</span> adapter connection?
        </div>
        <app-delete-connection-button [id]="connection.adidconn"></app-delete-connection-button>
      </div>
    </div>
    <div>
      <div class="text-sm text-text-300">Base url</div>
      <app-connection-url
        [adapter]="adapter"
        [id]="connection.adidconn"
        [path]="connection.path"
        [editMode]="authorized ?? false"
      >
      </app-connection-url>
    </div>
    <div class="mt-10 pb-10 flex flex-col gap-16">
      <div class="flex flex-col gap-1">
        <div class="text-sm leading-none text-text-300">Parameters</div>
        <app-params-list
          [id]="connection.adidconn"
          [params]="connection.params"
          [editMode]="authorized ?? false"
          [values]="paramValues"
          (onSave)="updateParams($event)"
          [loading]="(loading$ | async) ?? false"
        >
        </app-params-list>
      </div>
    </div>
    <div *ngIf="read" class="w-full pb-8">
      <div class="flex flex-col" [ngClass]="{ 'gap-6': !noOutContentType, 'gap-1': noOutContentType }">
        <div class="text-sm leading-none text-text-300">Response Payload</div>
        <app-payload
          [id]="connection.adidconn"
          [contentType]="outgoingContentType"
          type="Response"
          [editMode]="authorized ?? false"
        ></app-payload>
      </div>
    </div>
    <div *ngIf="write" class="w-full pb-8">
      <div class="flex flex-col" [ngClass]="{ 'gap-6': !noInContentType, 'gap-1': noInContentType }">
        <div class="text-sm leading-none text-text-300">Request Payload</div>
        <app-payload
          [id]="connection.adidconn"
          [contentType]="incomingContentType"
          type="Request"
          [editMode]="authorized ?? false"
        ></app-payload>
      </div>
      <div *ngIf="!noInContentType" class="w-full mt-8">
        <app-body [contentType]="incomingContentType" [body]="body" [file]="file" [text]="text"></app-body>
      </div>
    </div>
    <ng-container *ngLet="body.statusChanges | async as bodyStatus">
      <ng-container *ngLet="file.statusChanges | async as fileStatus">
        <ng-container *ngLet="text.statusChanges | async as textStatus">
          <p-button
            [label]="read ? 'Read Data' : 'Write Data'"
            icon="pi pi-database"
            (click)="consume()"
            [disabled]="
              write &&
              !noInContentType &&
              ((inIsBody && bodyStatus != 'VALID') ||
                (inIsFile && fileStatus != 'VALID') ||
                (inIsText && textStatus != 'VALID'))
            "
          ></p-button>
        </ng-container>
      </ng-container>
    </ng-container>
  </ng-template>
</app-role-checker>
